<?php
namespace Pinpoint\Conesso\Model\Api\Customer;

use Pinpoint\Conesso\Api\Repository\ContactsSyncRepositoryInterface;
use Pinpoint\Conesso\Api\Data\ContactSyncInterfaceFactory;
use Pinpoint\Conesso\Api\Data\ContactSyncInterface;
use Magento\Store\Model\StoreManagerInterface;
use Psr\Log\LoggerInterface;

class LogCustomer implements LogCustomerInterface
{
    private $contactSyncFactory;

    private $syncContactRepository;

    private $storeManager;

    private $logger;

    public function __construct(
        ContactsSyncRepositoryInterface $syncContactRepository,
        ContactSyncInterfaceFactory $contactSyncFactory,
        StoreManagerInterface $storeManager,
        LoggerInterface $logger
    ) {
        $this->syncContactRepository = $syncContactRepository;
        $this->contactSyncFactory = $contactSyncFactory;
        $this->storeManager = $storeManager;
        $this->logger = $logger;
    }

    public function logCustomer(\Magento\Customer\Api\Data\CustomerInterface $customer, $eventType)
    {
        $contactData = $this->contactSyncFactory->create();
        $data = [
            ContactSyncInterface::STORE_ID => (int) $this->storeManager->getStore()->getStoreId(),
            ContactSyncInterface::CUSTOMER_ID => (int) $customer->getId(),
            ContactSyncInterface::EVENT_TYPE => $eventType,
            ContactSyncInterface::IS_SYNCED => 0,

        ];
        $this->logger->debug(print_r($data,true));
        $contactData->setData($data);
        $this->syncContactRepository->save($contactData);
    }
}
